SystemOrganization addCategory: #'SqueakNxt-EtoysCompiler'!

RBProgramNodeVisitor subclass: #NxtPlayerTranslator
	instanceVariableNames: 'brick motors sensors variables getterSelectors setterSelectors scriptSelectors methods currentMorph programName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-EtoysCompiler'!

!NxtPlayerTranslator class methodsFor: 'instance creation' stamp: 'Richo 1/10/2011 16:34'!
on: aLegoNxtMorph
^ (self basicNew setBrick: aLegoNxtMorph) initialize! !

!NxtPlayerTranslator methodsFor: 'visiting' stamp: 'Richo 1/10/2011 18:27'!
acceptMessageNode: aMessageNode 
	| selector |
	selector := aMessageNode selector.
	(self rules includesKey: selector)
		ifTrue: [(self rules
				at: selector
				ifAbsent: [self error: selector printString , ': Not supported or invalid'])
				value: aMessageNode].
	(self etoysMessages includesKey: selector)
		ifTrue: [(self etoysMessages at: selector)
				value: aMessageNode].
	(self allGetterSelectors includes: selector)
		ifTrue: [| newNode | 
			self withCurrentMorph: (self morphFor: aMessageNode receiver name) do: [
			newNode := RBVariableNode
						named: (self slotForGetter: selector)].
			aMessageNode
				become: (newNode parent: aMessageNode parent).
			^ self visitNode: aMessageNode].
	(self allSetterSelectors includes: selector)
		ifTrue: [| newNode | 
			self withCurrentMorph: (self morphFor: aMessageNode receiver name) do: [
			newNode := RBAssignmentNode
						variable: (RBVariableNode
								named: (self slotForSetter: selector))
						value: aMessageNode arguments first].
			aMessageNode
				become: (newNode parent: aMessageNode parent).
			^ self visitNode: aMessageNode].
	(self allScriptSelectors includes: selector)
		ifTrue: [
self withCurrentMorph: (self morphFor: aMessageNode receiver name) do: [
aMessageNode selector: (self asLegalName: aMessageNode selector);
receiver: (RBVariableNode named: 'self')]].
	super acceptMessageNode: aMessageNode! !

!NxtPlayerTranslator methodsFor: 'visiting' stamp: 'Richo 1/10/2011 17:39'!
acceptMethodNode: aMethodNode 
	| argVars |
	argVars := aMethodNode allArgumentVariables.
	argVars size = 1
		ifTrue: [| varType |
varType :=  (self asNxcType: (self currentPlayerClass scripts at: aMethodNode selector) argumentVariables first variableType).
aMethodNode pragmas: (RBParser parseMethod: 'm <argTypes:''', varType ,'''>') pragmas
].
	aMethodNode selector: (self asLegalName: aMethodNode selector).
	^ super acceptMethodNode: aMethodNode.! !

!NxtPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/10/2011 17:36'!
allGetterSelectors
	^ getterSelectors inject: #() into: [:subTotal :next | subTotal, next]! !

!NxtPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/10/2011 17:13'!
allMorphs
	^ {brick},  motors, sensors! !

!NxtPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/10/2011 17:13'!
allMorphsDo: aBlock
	self allMorphs do: [:each |
		each notNil ifTrue: [aBlock value: each]
	]! !

!NxtPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/10/2011 17:36'!
allScriptSelectors
	^ scriptSelectors inject: #() into: [:subTotal :next | subTotal, next]! !

!NxtPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/10/2011 17:36'!
allSetterSelectors
	^ setterSelectors inject: #() into: [:subTotal :next | subTotal, next]! !

!NxtPlayerTranslator methodsFor: 'converting' stamp: 'Richo 1/10/2011 18:29'!
asLegalName: aString
"All variables, method names and task names must begin with a prefix representing the receiver."
^ currentMorph assuredPlayer uniqueNameForReference asLegalSelector, aString capitalized! !

!NxtPlayerTranslator methodsFor: 'converting' stamp: 'Richo 1/10/2011 18:52'!
asLegalTaskFlag: aSymbol 
	"Returns the name of the flag variable used to stop this task"
	^ (self asLegalTaskName: aSymbol) , 'Stepping'! !

!NxtPlayerTranslator methodsFor: 'converting' stamp: 'Richo 1/10/2011 18:51'!
asLegalTaskName: aSymbol
	"Returns the name of this task"
	^ self asLegalName: aSymbol, 'Task'! !

!NxtPlayerTranslator methodsFor: 'converting' stamp: 'Richo 1/10/2011 18:47'!
asNxcType: aSymbol
	^ aSymbol caseOf: {
		[#Number] -> [#long].
		[#Boolean] -> [#bool].
		[#String] -> [#string]
		}! !

!NxtPlayerTranslator methodsFor: 'converting' stamp: 'Richo 1/10/2011 18:52'!
asTaskFlag: aSymbol
	"Returns the name of the flag variable used to stop this task"
	^ (self asTaskName: aSymbol), 'Stepping'! !

!NxtPlayerTranslator methodsFor: 'converting' stamp: 'Richo 1/10/2011 18:50'!
asTaskName: aSymbol
	"Returns the name of this task"
	^ aSymbol, 'Task'! !

!NxtPlayerTranslator methodsFor: 'initialize-release' stamp: 'Richo 1/10/2011 17:05'!
collectGetterSelectors
	self allMorphsDo: [:morph | | selectors |
		selectors := getterSelectors at: morph ifAbsent: [getterSelectors at: morph put: OrderedCollection new].
		selectors addAll: (morph assuredPlayer slotInfo keys collect: [:selector | Utilities getterSelectorFor: selector])].
! !

!NxtPlayerTranslator methodsFor: 'initialize-release' stamp: 'Richo 1/10/2011 16:53'!
collectMotorsAndSensors
	"Finds out which motor and sensor morphs are connected to the nxt brick.
	It's not the fastest way (nor the cleanest) but it works..."
	| nxt |
	nxt := brick nxt.
	NxtPluggableDeviceMorph allSubInstancesDo: [:m | 
		m device port caseOf: {
			[nxt portA] -> [motors at: 1 put: m].
			[nxt portB] -> [motors at: 2 put: m].
			[nxt portC] -> [motors at: 3 put: m].
			[nxt port1] -> [sensors at: 1 put: m].
			[nxt port2] -> [sensors at: 2 put: m].
			[nxt port3] -> [sensors at: 3 put: m].
			[nxt port4] -> [sensors at: 4 put: m].
		} otherwise: []
	]! !

!NxtPlayerTranslator methodsFor: 'initialize-release' stamp: 'Richo 1/10/2011 17:08'!
collectScriptSelectors
	self
		allMorphsDo: [:morph | 
			| selectors | 
			selectors := scriptSelectors
						at: morph
						ifAbsent: [scriptSelectors at: morph put: OrderedCollection new].
			selectors
				addAll: (morph assuredPlayer class selectors
						reject: [:selector | ((getterSelectors at: morph)
									includes: selector)
								or: [(setterSelectors at: morph)
										includes: selector]])] ! !

!NxtPlayerTranslator methodsFor: 'initialize-release' stamp: 'Richo 1/10/2011 17:05'!
collectSetterSelectors
	self allMorphsDo: [:morph | | selectors |
		selectors := setterSelectors at: morph ifAbsent: [setterSelectors at: morph put: OrderedCollection new].
		selectors addAll: (morph assuredPlayer slotInfo keys collect: [:selector | Utilities setterSelectorFor: selector])].
! !

!NxtPlayerTranslator methodsFor: 'initialize-release' stamp: 'Richo 1/10/2011 18:21'!
collectSlots
	"Adds all the slots and they respective types to the variables dictionary."
	self allMorphsDo: [:morph | | slots |
		slots := variables at: morph ifAbsent: [variables at: morph put: Dictionary new].
		morph assuredPlayer slotInfo keysAndValuesDo: [:slotName :slotInfo | slots at: slotName put: slotInfo type]]! !

!NxtPlayerTranslator methodsFor: 'translating' stamp: 'Richo 1/10/2011 18:51'!
compileMainMethod: scriptName
	"Compiles the main method, which is the first method the nxt executes. It sends #setUp to configure the sensors, then it starts the script task"
methods add: 'main 
	<task>
	self setUp.
	self nxc: ''StartTask(', (self asLegalTaskName: scriptName) ,');'''.
! !

!NxtPlayerTranslator methodsFor: 'compiling' stamp: 'Richo 1/10/2011 18:53'!
compileNxtProgramSubclass
	| instVarNames instVarTypes |
	instVarNames := instVarTypes := ''.
	variables keysAndValuesDo: [:morph :vars |
	self withCurrentMorph: morph do: [
		vars keysAndValuesDo: [:varName :varType |
		instVarNames := instVarNames , (self asLegalName: varName) , ' '.
		instVarTypes := instVarTypes , (self asNxcType: varType), ' ']]].
	self createNxtProgramSubclassInstVarNames: instVarNames instVarTypes: instVarTypes.
	methods do: [:each | self programClass compileSilently: each classified: #autogenerated]! !

!NxtPlayerTranslator methodsFor: 'translating' stamp: 'Richo 1/10/2011 18:36'!
compileSetUpMethod
"Compiles the #setUp method, which gets executed once at the beginning of the program and its responsible for configuring the sensors and initialize all the inst vars. It also waits for 500 milliseconds (just to be sure all the sensors are correctly configured)"
| methodSource |
methodSource := WriteStream on: ''.
methodSource nextPutAll: 'setUp'; cr.
sensors doWithIndex: [:m :index |
	m isNil ifFalse: [ | zeroBasedIndex |
		zeroBasedIndex := (index - 1) asString.
		methodSource nextPutAll: '	self setSensor'.
		m device type caseOf: {
			[SensorType lowspeed9V] -> [methodSource nextPutAll: 'LowSpeed: ', zeroBasedIndex].
			[SensorType lightActive] -> [methodSource nextPutAll: 'Light: ', zeroBasedIndex, ' active: true'].
			[SensorType lightInactive] -> [methodSource nextPutAll: 'Light: ', zeroBasedIndex, ' active: false'].
			[SensorType soundDba] -> [methodSource nextPutAll: 'Sound: ', zeroBasedIndex, ' scaling: false'].
			[SensorType soundDb] -> [methodSource nextPutAll: 'Sound: ', zeroBasedIndex, ' scaling: true'].
			[SensorType switch] -> [methodSource nextPutAll: 'Touch: ', zeroBasedIndex]
		} otherwise: [].
		methodSource nextPut: $.; cr.
	]
].
variables keysAndValuesDo: [:morph :vars|
	self withCurrentMorph: morph do: [
	vars keys do: [:varName |
	methodSource nextPutAll: (self asLegalName: varName), ' := ', (morph assuredPlayer instVarNamed: varName) printString, '.'; cr]]].
methodSource nextPutAll: 'self wait: 500.'.
methods add: methodSource contents! !

!NxtPlayerTranslator methodsFor: 'translating' stamp: 'Richo 1/10/2011 18:51'!
compileTaskNamed: aSymbol 
	"Each task is defined as a loop whose condition is the task's flag variable. So, if we want to stop the task we just need to set the flag to false, and the task will stop at the next tick. This is a workaround, a correct implementation would call StopTask() but this function is only supported by the enhanced firmware and I *really* need to be able to stop tasks from Etoys, so this solution (even though far from perfect) is good enough. This code also takes into account the frequency and tickingRate parameters of the script. To do that, it encloses the script call in a #timesRepeat: message and it puts a #wait: afterwards "
	| rule |
	self assert: [(scriptSelectors at: currentMorph) includes: aSymbol]
		description: 'Not a ' , currentMorph assuredPlayer uniqueNameForReference , '''s valid script'.
	(variables at: currentMorph) at: (self asTaskFlag: aSymbol) put: #Boolean.
	rule := '@taskName 
	<task>
	@taskFlag := true. 
	[@taskFlag] 
		whileTrue: [@frequency timesRepeat: [self @task].
			self wait: @delay]'.
	rule := rule copyReplaceAll: '@taskName' with: (self asLegalTaskName: aSymbol).
	rule := rule copyReplaceAll: '@taskFlag' with: (self asLegalTaskFlag: aSymbol).
	rule := rule copyReplaceAll: '@task' with: (self asLegalName: aSymbol).
	rule := rule copyReplaceAll: '@frequency' with: (self frequencyOfScript: aSymbol).
	rule := rule copyReplaceAll: '@delay' with: (self delayOfScript: aSymbol).
	methods add: rule! !

!NxtPlayerTranslator methodsFor: 'compiling' stamp: 'Richo 1/10/2011 18:53'!
createNxtProgramSubclassInstVarNames: aString instVarTypes: anotherString 
	SystemChangeNotifier uniqueInstance doSilently: [
		NxtProgram subclass: self programName
			instanceVariableNames: aString
			instanceVariableTypes: anotherString
			classVariableNames: ''
			poolDictionaries: ''
			category: 'NxtPrograms']! !

!NxtPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/10/2011 17:22'!
currentPlayer
	^ currentMorph assuredPlayer! !

!NxtPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/10/2011 17:22'!
currentPlayerClass
	^ self currentPlayer class! !

!NxtPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/10/2011 18:15'!
delayOfScript: scriptName
 	"To be in accordance with the script tick rate, we put a delay at the end of each task. How long the delay would be?"
	^ (1000 / (currentMorph assuredPlayer scriptInstantiationForSelector: scriptName) tickingRate) rounded asString! !

!NxtPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/10/2011 17:28'!
etoysMessages
"I don't know why but recent versions of Etoys use this weird messages instead of the operators."
^ {
#eToysLT: -> [:node | node selector: #<].
#eToysLE: -> [:node | node selector: #<=].
#eToysEQ: -> [:node | node selector: #=].
#eToysNE: -> [:node | node selector: #~=].
#eToysGT: -> [:node | node selector: #>].
#eToysGE: -> [:node | node selector: #>=].
#isDivisibleBy: -> [:node | self error: '#isDivisibleBy: Not supported yet'].
} as: Dictionary! !

!NxtPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/10/2011 18:15'!
frequencyOfScript: scriptName
	"To be in accordance with the script frequency property we enclose the script call in a #timesRepeat: message. How many times should we repeat the script?"
	^ (currentMorph assuredPlayer scriptInstantiationForSelector: scriptName) frequency rounded asString! !

!NxtPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/10/2011 19:02'!
indexFor: aVariableNode in: aCollection
	"Basically, it tries to determine if the variable node is representing an object in the collection. If it is, it returns its index as a literal node (zero based for nxc compatibility)"
	| index |
	aVariableNode name = 'self' 
		ifTrue: [index := (aCollection indexOf: currentMorph)]
		ifFalse: [aCollection doWithIndex: [:morph :i| 
(morph notNil and: [morph assuredPlayer uniqueNameForReference = aVariableNode token value]) ifTrue: [index := i. thisContext return: nil]]].
	^ index isNil ifTrue: [self error: 'Index not found'] ifFalse: [self literal: index - 1]! !

!NxtPlayerTranslator methodsFor: 'initialize-release' stamp: 'Richo 1/10/2011 17:02'!
initialize
	super initialize.
	motors := Array new: 3.
	sensors := Array new: 4.
	variables := Dictionary new.
	getterSelectors := Dictionary new.
	setterSelectors := Dictionary new.
	scriptSelectors := Dictionary new.
	self collectMotorsAndSensors; 
		 collectSlots;
		 collectGetterSelectors;
		 collectSetterSelectors;
		 collectScriptSelectors! !

!NxtPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/10/2011 17:33'!
literal: aLiteralObject
	^ RBLiteralValueNode value: aLiteralObject! !

!NxtPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/10/2011 18:00'!
morphFor: receiverName
	^ receiverName = 'self'
				ifTrue: [currentMorph]
				ifFalse: [self allMorphs
						detect: [:each | each assuredPlayer uniqueNameForReference = receiverName]]! !

!NxtPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/10/2011 18:54'!
programClass
	"Returns the temporary class we are using to compile the code"
	^ Smalltalk at: self programName ifAbsent: []! !

!NxtPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/10/2011 18:53'!
programName
	^ programName ifNil: [self programName: #NxtEtoysProgram]! !

!NxtPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/10/2011 18:54'!
programName: aSymbol
	"It tries to set programName to aSymbol, but if the class already exists it appends as many R as necessary. It's just a temporary class and it will be removed right away"
	^ (Smalltalk includesKey: aSymbol)
		ifTrue: [self programName: (aSymbol , #R) asSymbol]
		ifFalse: [programName := aSymbol]! !

!NxtPlayerTranslator methodsFor: 'compiling' stamp: 'Richo 1/10/2011 18:56'!
removeNxtProgramSubclass
	"After translation is done we silently remove the temporary class"
	SystemChangeNotifier uniqueInstance doSilently: [
		self programClass ifNotNilDo: [:class | class removeFromSystem]]! !

!NxtPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/10/2011 18:51'!
rules
"These are the rules to modify the parse tree of the SqueakNxtPlayer scripts. Most of the time, I just need to rename the selector, change the receiver to self and set the correct list of arguments. Other times (such as #getAudible or #getActive) the rule is a little more complicated"
| selfVar |
selfVar := RBVariableNode named: 'self'.
^ {
#getIsPressed -> [:node | 
	node arguments: {self indexFor: node receiver in: sensors};
		 selector: #sensorBoolean:;
		receiver: selfVar].
#playTone: -> [:node | 
	node receiver: selfVar;
		  arguments: node arguments, {self literal: 200};
		  selector: #playTone:duration:].
#setPower: -> [:node | 
	node arguments: {self indexFor: node receiver in: motors} , node arguments;
		selector: #onFwd:speed:;
		receiver: selfVar].
#getAudible -> [:node | | copy | "(self sensorType: n) = 8"
	copy := node copy.
	node receiver: copy; arguments: {self literal: SensorType soundDba}; selector: #=.
	copy arguments: {self indexFor: copy receiver in: sensors}; selector: #sensorType:; receiver: selfVar].
#getActive -> [:node | | copy | "(self sensorType: n) = 5"
	copy := node copy.
	node receiver: copy; arguments: {self literal: SensorType lightActive}; selector: #=.
	copy arguments: {self indexFor: copy receiver in: sensors}; selector: #sensorType:; receiver: selfVar].
#getDistanceCm -> [:node |
	node arguments: {self indexFor: node receiver in: sensors};
		 selector: #sensorUS:;
		receiver: selfVar].
#getValue -> [:node |
	node arguments: {self indexFor: node receiver in: sensors};
			selector: #sensorValue:;
			receiver: selfVar].
#float -> [:node |
	node arguments: {self indexFor: node receiver in: motors};
		selector: #float:;
		receiver: selfVar].
#brake -> [:node |
	node arguments: {self indexFor: node receiver in: motors};
		selector: #off:;
		receiver: selfVar].
#playSoundFile: -> [:node | node selector: #playFile:; receiver: selfVar].
#getPower -> [:node |
	node arguments: {self indexFor: node receiver in: motors};
		selector: #motorPower:;
		receiver: selfVar].
#setActive: -> [:node |
	node arguments: {self indexFor: node receiver in: sensors}, node arguments;
		 selector: #setSensorLight:active:;
		receiver: selfVar].
#setAudible: -> [:node |
	node arguments: {self indexFor: node receiver in: sensors}, {RBMessageNode receiver: node arguments first selector: #not};
		 selector: #setSensorSound:scaling:;
		receiver: selfVar].
#startScript: -> [:node |
	self withCurrentMorph: (self morphFor: node receiver name) do: [	
	self compileTaskNamed: node arguments first value.
	node arguments: {self literal: 'StartTask(', (self asLegalTaskName: node arguments first value) ,');'};
		 selector: #nxc:;
		 receiver: selfVar]].
#stopScript: -> [:node |
	self withCurrentMorph: (self morphFor: node receiver name) do: [	
	self compileTaskNamed: node arguments first value.
	node arguments: {self literal: (self asLegalTaskFlag: node arguments first value), ' = false;'};
		 selector: #nxc:;
		 receiver: selfVar]].
#pauseScript: -> [:node | "The same as #stopScript:"
	self withCurrentMorph: (self morphFor: node receiver name) do: [	
	self compileTaskNamed: node arguments first value.
	node arguments: {self literal: (self asLegalTaskFlag: node arguments first value), ' = false;'};
		 selector: #nxc:;
		 receiver: selfVar]].
#doScript: -> [:node | | args | args := node arguments.
	node arguments: #(); selector: args first value; receiver: selfVar]
} as: Dictionary! !

!NxtPlayerTranslator methodsFor: 'private' stamp: 'Richo 1/10/2011 16:35'!
setBrick: aMorph
	brick := aMorph! !

!NxtPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/10/2011 18:27'!
slotForGetter: getterSelector
	| slotName |
	slotName := currentMorph assuredPlayer slotInfo keys
				detect: [:slot | (Utilities getterSelectorFor: slot)
						= getterSelector].
	^ self asLegalName: slotName! !

!NxtPlayerTranslator methodsFor: 'accessing' stamp: 'Richo 1/10/2011 18:28'!
slotForSetter: setterSelector
	| slotName |
	slotName := currentMorph assuredPlayer slotInfo keys
				detect: [:slot | (Utilities setterSelectorFor: slot)
						= setterSelector].
	^ self asLegalName: slotName! !

!NxtPlayerTranslator methodsFor: 'translating' stamp: 'Richo 1/10/2011 18:56'!
translateMainScript: scriptName of: scriptOwner 
	self initialize.
	self
		assert: [self allMorphs includes: scriptOwner]
		description: 'The morph is not connected to the Nxt brick'.
	methods := Set new.
	self
		withCurrentMorph: scriptOwner
		do: [self compileSetUpMethod; compileMainMethod: scriptName; compileTaskNamed: scriptName].
	scriptSelectors
		keysAndValuesDo: [:morph :scripts | self
				withCurrentMorph: morph
				do: [scripts
						do: [:each | 
							| node | 
							self visitNode: (node := self currentPlayerClass parseTreeFor: each).
							methods add: node formattedCode]]].
	[self compileNxtProgramSubclass.
	^ self programClass asNxcProgram: scriptName] 
		ensure: [self removeNxtProgramSubclass]! !

!NxtPlayerTranslator methodsFor: 'translating' stamp: 'Richo 1/10/2011 17:21'!
withCurrentMorph: aMorph do: aBlock
	| old |
	old := currentMorph.
	currentMorph := aMorph.
	aBlock value.
	currentMorph := old! !

RBProgramNodeVisitor subclass: #NxtPlayerTranslatorViejo
	instanceVariableNames: 'programName motors sensors morph variables methods validScripts brick'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakNxt-EtoysCompiler'!

!NxtPlayerTranslatorViejo class methodsFor: 'utilities' stamp: 'Richo 1/10/2011 15:33'!
avoidNameClash
"
Utility method. Compiles an empty method in SqueakNxtPlayer for each nxc primitive rule selector. This way we prevent the user from creating a script with an invalid name.
Execute this if the list of rules changes.
"
NxcPrimitiveRule allRulesSelectors, #(main setUp) 
	select: [:each | (each isKeyword and: [each numArgs = 1]) or: [each isUnary]]
	thenDo: [:selector | | method |
	method := String streamContents: [:stream |
		selector isUnary
			ifTrue: [stream nextPutAll: selector]
			ifFalse: [selector keywords doWithIndex: [:each :index | stream nextPutAll: each; space; nextPutAll: 'obj', index asString; space]].
		stream cr; nextPutAll: '"This method''s name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"'
		].
	"Warning, we don't want to lose an already existing method"
	(SqueakNxtPlayer canUnderstand: selector)
		ifFalse: [SqueakNxtPlayer compile: method classified: #'*squeaknxt-etoyscompiler-nxc commands']
].! !

!NxtPlayerTranslatorViejo class methodsFor: 'instance creation' stamp: 'Richo 1/10/2011 16:28'!
on: aMorph
	^(self basicNew setBrick: aMorph) initialize! !

!NxtPlayerTranslatorViejo methodsFor: 'visiting' stamp: 'Richo 1/10/2011 16:27'!
acceptMessageNode: aMessageNode 
	| selector |
	selector := aMessageNode selector.
	(self rules includesKey: selector)
		ifTrue: [(self rules
				at: selector
				ifAbsent: [self error: selector printString , ': Not supported or invalid'])
				value: aMessageNode].
	(self etoysMessages includesKey: selector)
		ifTrue: [(self etoysMessages at: selector)
				value: aMessageNode].
	(self slotGetters includes: selector)
		ifTrue: [| newNode | 
			newNode := RBVariableNode
						named: (self asLegalName: (self slotForGetter: selector)).
			aMessageNode
				become: (newNode parent: aMessageNode parent).
			^ self visitNode: aMessageNode].
	(self slotSetters includes: selector)
		ifTrue: [| newNode | 
			newNode := RBAssignmentNode
						variable: (RBVariableNode
								named: (self asLegalName: (self slotForSetter: selector)))
						value: aMessageNode arguments first.
			aMessageNode
				become: (newNode parent: aMessageNode parent).
			^ self visitNode: aMessageNode].
	(validScripts includes: selector)
		ifTrue: [aMessageNode selector: (self asLegalName: aMessageNode selector forReceiver:aMessageNode receiver name)].
	super acceptMessageNode: aMessageNode! !

!NxtPlayerTranslatorViejo methodsFor: 'visiting' stamp: 'Richo 1/10/2011 15:55'!
acceptMethodNode: aMethodNode 
	| argVars |
	argVars := aMethodNode allArgumentVariables.
	argVars size = 1
		ifTrue: [| varType |
varType :=  (self asNxcType: (morph assuredPlayer class scripts at: aMethodNode selector) argumentVariables first variableType).
aMethodNode pragmas: (RBParser parseMethod: 'm <argTypes:''', varType ,'''>') pragmas
].
	aMethodNode selector: (self asLegalName: aMethodNode selector).
	^ super acceptMethodNode: aMethodNode.! !

!NxtPlayerTranslatorViejo methodsFor: 'accessing' stamp: 'Richo 1/10/2011 16:19'!
asLegalName: aString
"All variables, method names and task names must begin with a prefix representing the receiver."
^ self asLegalName: aString forReceiver: morph assuredPlayer uniqueNameForReference! !

!NxtPlayerTranslatorViejo methodsFor: 'accessing' stamp: 'Richo 1/10/2011 16:17'!
asLegalName: aSymbol forReceiver: receiverName
	^ receiverName asLegalSelector , aSymbol capitalized
	! !

!NxtPlayerTranslatorViejo methodsFor: 'private' stamp: 'Richo 1/5/2011 17:34'!
asNxcType: aSymbol
	^ aSymbol caseOf: {
		[#Number] -> [#long].
		[#Boolean] -> [#bool].
		[#String] -> [#string]
		}! !

!NxtPlayerTranslatorViejo methodsFor: 'private-tasks' stamp: 'Richo 1/5/2011 16:05'!
asTaskFlag: aSymbol
	"Returns the name of the flag variable used to stop this task"
	^ (self asTaskName: aSymbol), 'Stepping'! !

!NxtPlayerTranslatorViejo methodsFor: 'private-tasks' stamp: 'Richo 1/10/2011 15:53'!
asTaskName: aSymbol
	"Returns the name of this task"
	^ self asLegalName: (aSymbol, 'Task')! !

!NxtPlayerTranslatorViejo methodsFor: 'private' stamp: 'Richo 1/10/2011 15:49'!
collectInstVars
	"Adds all the slots and they respective types to the variables dictionary"
	morph assuredPlayer slotInfo associationsDo: [:association |
		variables at: (self asLegalName: association key) put: (self asNxcType: association value type) -> (morph assuredPlayer instVarNamed: association key)
	]! !

!NxtPlayerTranslatorViejo methodsFor: 'private' stamp: 'Richo 1/10/2011 16:28'!
collectMotorsAndSensors
	"Finds out which motor and sensor morphs are connected to the nxt brick.
	It's not the fastest way (nor the cleanest) but it works..."
	| nxt |
	motors := Array new: 3.
	sensors := Array new: 4.
	nxt := brick nxt.
	NxtPluggableDeviceMorph allSubInstancesDo: [:m | 
		m device port caseOf: {
			[nxt portA] -> [motors at: 1 put: m].
			[nxt portB] -> [motors at: 2 put: m].
			[nxt portC] -> [motors at: 3 put: m].
			[nxt port1] -> [sensors at: 1 put: m].
			[nxt port2] -> [sensors at: 2 put: m].
			[nxt port3] -> [sensors at: 3 put: m].
			[nxt port4] -> [sensors at: 4 put: m].
		} otherwise: []
	]
! !

!NxtPlayerTranslatorViejo methodsFor: 'private' stamp: 'Richo 1/10/2011 16:29'!
collectValidScripts
| rejectionBlock scripts |
rejectionBlock := [:selector | (self slotGetters includes: selector) or: [self slotSetters includes: selector]].
scripts := WriteStream on: #().
{brick}, motors, sensors do: [:each | each notNil ifTrue: [scripts nextPutAll: (each assuredPlayer class selectors reject: rejectionBlock)]].
^ validScripts := scripts contents! !

!NxtPlayerTranslatorViejo methodsFor: 'private' stamp: 'Richo 1/6/2011 15:27'!
compileMainMethod: scriptName
	"Compiles the main method, which is the first method the nxt executes. It sends #setUp to configure the sensors, then it starts the script task"
methods add: 'main 
	<task>
	self setUp.
	self nxc: ''StartTask(', (self asTaskName: scriptName) ,');'''.
! !

!NxtPlayerTranslatorViejo methodsFor: 'private' stamp: 'Richo 1/10/2011 15:52'!
compileNxtProgramSubclass
	| instVarNames instVarTypes |
	instVarNames := instVarTypes := ''.
	variables keysAndValuesDo: [:varName :varTypeAndValue |
		instVarNames := instVarNames , varName , ' '.
		instVarTypes := instVarTypes , varTypeAndValue key, ' '.
		].
	self createNxtProgramSubclassInstVarNames: instVarNames instVarTypes: instVarTypes.
	methods do: [:each | self programClass compileSilently: each classified: #autogenerated]! !

!NxtPlayerTranslatorViejo methodsFor: 'private' stamp: 'Richo 1/10/2011 15:50'!
compileSetUpMethod
"Compiles the #setUp method, which gets executed once at the beginning of the program and its responsible for configuring the sensors and initialize all the inst vars. It also waits for 500 milliseconds (just to be sure all the sensors are correctly configured)"
| methodSource |
methodSource := WriteStream on: ''.
methodSource nextPutAll: 'setUp'; cr.
sensors doWithIndex: [:m :index |
	m isNil ifFalse: [ | zeroBasedIndex |
		zeroBasedIndex := (index - 1) asString.
		methodSource nextPutAll: '	self setSensor'.
		m device type caseOf: {
			[SensorType lowspeed9V] -> [methodSource nextPutAll: 'LowSpeed: ', zeroBasedIndex].
			[SensorType lightActive] -> [methodSource nextPutAll: 'Light: ', zeroBasedIndex, ' active: true'].
			[SensorType lightInactive] -> [methodSource nextPutAll: 'Light: ', zeroBasedIndex, ' active: false'].
			[SensorType soundDba] -> [methodSource nextPutAll: 'Sound: ', zeroBasedIndex, ' scaling: false'].
			[SensorType soundDb] -> [methodSource nextPutAll: 'Sound: ', zeroBasedIndex, ' scaling: true'].
			[SensorType switch] -> [methodSource nextPutAll: 'Touch: ', zeroBasedIndex]
		} otherwise: [].
		methodSource nextPut: $.; cr.
	]
].
variables keysAndValuesDo: [:varName :varTypeAndValue |
	methodSource nextPutAll: varName, ' := ', varTypeAndValue value printString, '.'; cr.
].
methodSource nextPutAll: 'self wait: 500.'.
methods add: methodSource contents! !

!NxtPlayerTranslatorViejo methodsFor: 'private-tasks' stamp: 'Richo 1/10/2011 15:59'!
compileTaskNamed: aSymbol
	"Each task is defined as a loop whose condition is the task's flag variable. So, if we want to stop the task we just need to set the flag to false, and the task will stop at the next tick. This is a workaround, a correct implementation would call StopTask() but this function is only supported by the enhanced firmware and I *really* need to be able to stop tasks from Etoys, so this solution (even though far from perfect) is good enough.
	This code also takes into account the frequency and tickingRate parameters of the script. To do that, it encloses the script call in a #timesRepeat: message and it puts a #wait: afterwards"
| rule |
variables at: (self asTaskFlag: aSymbol) put: #bool -> nil.
rule := '@taskName 
	<task>
	@taskFlag := true. 
	[@taskFlag] 
		whileTrue: [@frequency timesRepeat: [self @task].
			self wait: @delay]'.
rule := rule copyReplaceAll: '@taskName' with: (self asTaskName: aSymbol).
rule := rule copyReplaceAll: '@taskFlag' with: (self asTaskFlag: aSymbol).
rule := rule copyReplaceAll: '@task' with: (self asLegalName: aSymbol).
rule := rule copyReplaceAll: '@frequency' with: (self frequencyOfScript: aSymbol).
rule := rule copyReplaceAll: '@delay' with: (self delayOfScript: aSymbol).
methods add: rule.! !

!NxtPlayerTranslatorViejo methodsFor: 'private' stamp: 'Richo 1/5/2011 16:37'!
createNxtProgramSubclassInstVarNames: aString instVarTypes: anotherString 
	SystemChangeNotifier uniqueInstance doSilently: [
		NxtProgram subclass: self programName
			instanceVariableNames: aString
			instanceVariableTypes: anotherString
			classVariableNames: ''
			poolDictionaries: ''
			category: 'NxtPrograms']! !

!NxtPlayerTranslatorViejo methodsFor: 'private-tasks' stamp: 'Richo 1/5/2011 16:48'!
delayOfScript: scriptName
 	"To be in accordance with the script tick rate, we put a delay at the end of each task. How long the delay would be?"
	^ (1000 / (morph assuredPlayer scriptInstantiationForSelector: scriptName) tickingRate) rounded asString! !

!NxtPlayerTranslatorViejo methodsFor: 'private' stamp: 'Richo 1/5/2011 15:43'!
etoysMessages
"I don't know why but recent versions of Etoys use this weird messages instead of the operators."
^ {
#eToysLT: -> [:node | node selector: #<].
#eToysLE: -> [:node | node selector: #<=].
#eToysEQ: -> [:node | node selector: #=].
#eToysNE: -> [:node | node selector: #~=].
#eToysGT: -> [:node | node selector: #>].
#eToysGE: -> [:node | node selector: #>=].
#isDivisibleBy: -> [:node | self error: '#isDivisibleBy: Not supported yet'].
} as: Dictionary! !

!NxtPlayerTranslatorViejo methodsFor: 'private-tasks' stamp: 'Richo 1/5/2011 16:50'!
frequencyOfScript: scriptName
	"To be in accordance with the script frequency property we enclose the script call in a #timesRepeat: message. How many times should we repeat the script?"
	^ (morph assuredPlayer scriptInstantiationForSelector: scriptName) frequency rounded asString! !

!NxtPlayerTranslatorViejo methodsFor: 'private' stamp: 'Richo 1/5/2011 11:01'!
indexFor: aVariableNode in: aCollection
	"Basically, it tries to determine if the variable node is representing an object in the collection. If it is, it returns its index as a literal node (zero based for nxc compatibility)"
	| index |
	index := 0.
	aCollection do: [:each | 
	index := index + 1.
(each notNil and: [each assuredPlayer uniqueNameForReference = aVariableNode token value]) ifTrue: [^self literal: index - 1]].
	^ self error: 'Index not found'! !

!NxtPlayerTranslatorViejo methodsFor: 'private' stamp: 'Richo 1/4/2011 11:23'!
literal: aLiteralObject
	^ RBLiteralValueNode value: aLiteralObject! !

!NxtPlayerTranslatorViejo methodsFor: 'private' stamp: 'Richo 1/6/2011 16:13'!
programClass
	"Returns the temporary class we are using to compile the code"
	^ Smalltalk at: self programName ifAbsent: []! !

!NxtPlayerTranslatorViejo methodsFor: 'accessing' stamp: 'Richo 1/5/2011 10:22'!
programName
	^ programName ifNil: [self programName: #NxtEtoysProgram]! !

!NxtPlayerTranslatorViejo methodsFor: 'private' stamp: 'Richo 1/5/2011 10:54'!
programName: aSymbol
	"It tries to set programName to aSymbol, but if the class already exists it appends as many R as necessary. It's just a temporary class and it will be removed right away"
	^ (Smalltalk includesKey: aSymbol)
		ifTrue: [self programName: (aSymbol , #R) asSymbol]
		ifFalse: [programName := aSymbol]! !

!NxtPlayerTranslatorViejo methodsFor: 'accessing' stamp: 'Richo 1/10/2011 15:37'!
receiverPrefix
	"All variables, method names and task names must begin with a prefix representing the receiver. This returns the prefix for the current morph"
	^ morph assuredPlayer uniqueNameForReference asLegalSelector! !

!NxtPlayerTranslatorViejo methodsFor: 'private' stamp: 'Richo 1/5/2011 11:07'!
removeNxtProgramSubclass
	"After translation is done we silently remove the temporary class"
	SystemChangeNotifier uniqueInstance doSilently: [
		self programClass ifNotNilDo: [:class | class removeFromSystem]]! !

!NxtPlayerTranslatorViejo methodsFor: 'private' stamp: 'Richo 1/5/2011 16:43'!
rules
"These are the rules to modify the parse tree of the SqueakNxtPlayer scripts. Most of the time, I just need to rename the selector, change the receiver to self and set the correct list of arguments. Other times (such as #getAudible or #getActive) the rule is a little more complicated"
| selfVar |
selfVar := RBVariableNode named: 'self'.
^ {
#getIsPressed -> [:node | 
	node arguments: {self indexFor: node receiver in: sensors};
		 selector: #sensorBoolean:;
		receiver: selfVar].
#playTone: -> [:node | 
	node receiver: selfVar;
		  arguments: node arguments, {self literal: 200};
		  selector: #playTone:duration:].
#setPower: -> [:node | 
	node arguments: {self indexFor: node receiver in: motors} , node arguments;
		selector: #onFwd:speed:;
		receiver: selfVar].
#getAudible -> [:node | | copy | "(self sensorType: n) = 8"
	copy := node copy.
	node receiver: copy; arguments: {self literal: SensorType soundDba}; selector: #=.
	copy arguments: {self indexFor: copy receiver in: sensors}; selector: #sensorType:; receiver: selfVar].
#getActive -> [:node | | copy | "(self sensorType: n) = 5"
	copy := node copy.
	node receiver: copy; arguments: {self literal: SensorType lightActive}; selector: #=.
	copy arguments: {self indexFor: copy receiver in: sensors}; selector: #sensorType:; receiver: selfVar].
#getDistanceCm -> [:node |
	node arguments: {self indexFor: node receiver in: sensors};
		 selector: #sensorUS:;
		receiver: selfVar].
#getValue -> [:node |
	node arguments: {self indexFor: node receiver in: sensors};
			selector: #sensorValue:;
			receiver: selfVar].
#float -> [:node |
	node arguments: {self indexFor: node receiver in: motors};
		selector: #float:;
		receiver: selfVar].
#brake -> [:node |
	node arguments: {self indexFor: node receiver in: motors};
		selector: #off:;
		receiver: selfVar].
#playSoundFile: -> [:node | node selector: #playFile:; receiver: selfVar].
#getPower -> [:node |
	node arguments: {self indexFor: node receiver in: motors};
		selector: #motorPower:;
		receiver: selfVar].
#setActive: -> [:node |
	node arguments: {self indexFor: node receiver in: sensors}, node arguments;
		 selector: #setSensorLight:active:;
		receiver: selfVar].
#setAudible: -> [:node |
	node arguments: {self indexFor: node receiver in: sensors}, {RBMessageNode receiver: node arguments first selector: #not};
		 selector: #setSensorSound:scaling:;
		receiver: selfVar].
#startScript: -> [:node |
	self compileTaskNamed: node arguments first value.
	node arguments: {self literal: 'StartTask(', (self asTaskName: node arguments first value) ,');'};
		 selector: #nxc:;
		 receiver: selfVar].
#stopScript: -> [:node |
	self compileTaskNamed: node arguments first value.
	node arguments: {self literal: (self asTaskFlag: node arguments first value), ' = false;'};
		 selector: #nxc:;
		 receiver: selfVar].
#pauseScript: -> [:node | "The same as #stopScript:"
	self compileTaskNamed: node arguments first value.
	node arguments: {self literal: (self asTaskFlag: node arguments first value), ' = false;'};
		 selector: #nxc:;
		 receiver: selfVar].
#doScript: -> [:node | | args | args := node arguments.
	node arguments: #(); selector: args first value; receiver: selfVar]
} as: Dictionary! !

!NxtPlayerTranslatorViejo methodsFor: 'private' stamp: 'Richo 1/10/2011 16:28'!
setBrick: aMorph
	brick := aMorph ! !

!NxtPlayerTranslatorViejo methodsFor: 'private' stamp: 'Richo 1/5/2011 17:57'!
slotForGetter: selector
	^ morph assuredPlayer slotInfo keys detect: [:slot | (Utilities getterSelectorFor: slot) = selector]! !

!NxtPlayerTranslatorViejo methodsFor: 'private' stamp: 'Richo 1/5/2011 17:57'!
slotForSetter: selector
	^ morph assuredPlayer slotInfo keys detect: [:slot | (Utilities setterSelectorFor: slot) = selector]! !

!NxtPlayerTranslatorViejo methodsFor: 'private' stamp: 'Richo 1/10/2011 16:31'!
slotGetters
| getters |
getters := WriteStream on: #().
{brick}, motors, sensors do: [:each |
	each notNil ifTrue: [
		getters nextPutAll: (each assuredPlayer slotInfo keys collect: [:selector | Utilities getterSelectorFor: selector])]].
^ getters contents! !

!NxtPlayerTranslatorViejo methodsFor: 'private' stamp: 'Richo 1/10/2011 16:31'!
slotSetters
| setters |
setters := WriteStream on: #().
{brick}, motors, sensors do: [:each |
	each notNil ifTrue: [
		setters nextPutAll: (each assuredPlayer slotInfo keys collect: [:selector | Utilities setterSelectorFor: selector])]].
^ setters contents! !

!NxtPlayerTranslatorViejo methodsFor: 'translating' stamp: 'Richo 1/10/2011 16:26'!
translateMainScript: scriptName
	"It translates the script given as a parameter to nxc. It creates a temporary NxtProgram subclass to hold the code which will be translated to nxc. After translation is done, it removes the temporary class.
	Steps:
	* Collect motors and sensors.
	* Collect instVars.
	* Compile #setUp method.
	* Compile #main method.
	* Compile the script task.
	* Compile all scripts (Do not compile slot accessors).
	* Compile subclass.
	* Translate program to nxc
	* Remove temporary class.
	* Return nxc program"
	| playerClass |
	[methods := Set new.
	variables := Dictionary new.
	self collectMotorsAndSensors;
		 collectInstVars;
		 collectValidScripts;
		 compileSetUpMethod;
		 compileMainMethod: scriptName;
		 compileTaskNamed: scriptName.
	{morph}, motors, sensors do: [:m |
	m notNil ifTrue: [
	playerClass := m assuredPlayer class.
	playerClass selectors do: [:each | | node |
	(playerClass scripts includesKey: each) ifTrue: [self visitNode: (node := playerClass parseTreeFor: each).
		methods add: node formattedCode]]]].
	self compileNxtProgramSubclass.
	^ self programClass asNxcProgram: scriptName] 
		ensure: [self removeNxtProgramSubclass]! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
and: obj1 
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
arcCos
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
arcSin
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
arcTan
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
ceiling
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
cos
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
degreeArcTan
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
degreeCos
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
degreeSin
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
degreeTan
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
doWhileTrue: obj1 
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
exp
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
float: obj1 
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
floor
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
ifFalse: obj1 
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
ifTrue: obj1 
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
ln
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
log
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
main
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
motorPower: obj1 
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
motorSpeed: obj1 
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
negated
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler' stamp: 'Richo 1/10/2011 14:35'!
newScriptorAround: aPhrase
	Transcript show: 'newScriptorAround:'; cr.
	^ super newScriptorAround: aPhrase! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
not
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
off: obj1 
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
or: obj1 
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
playFile: obj1 
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
raisedTo: obj1 
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
repeat
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler' stamp: 'Richo 1/10/2011 15:32'!
scriptEditorFor: aSelector
	Transcript show: 'scriptEditorFor:'; cr.
	^ super scriptEditorFor: aSelector! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler' stamp: 'Richo 1/10/2011 15:32'!
scriptEditorForNoCng: aSelector
	Transcript show: 'scriptEditorForNoCng:'; cr.
	^ super scriptEditorForNoCng: aSelector.! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
sensorBoolean: obj1 
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
sensorNormalized: obj1 
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
sensorRaw: obj1 
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
sensorScaled: obj1 
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
sensorType: obj1 
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
sensorUS: obj1 
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
sensorValue: obj1 
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
setSensorLight: obj1 
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
setSensorLowSpeed: obj1 
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
setSensorSound: obj1 
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
setSensorTouch: obj1 
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
setUp
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
sin
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
sqrt
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
tan
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
timesRepeat: obj1 
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
truncated
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
wait: obj1 
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
whileTrue
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !

!SqueakNxtPlayer methodsFor: '*squeaknxt-etoyscompiler-nxc commands' stamp: 'Richo 1/5/2011 17:10'!
whileTrue: obj1 
"This method's name is a nxc reserved word. I declared it just to prevent the user from creating a script with this same name"! !
